package buildx

const (
	AMD64 string = "amd64"
	ARM64 string = "arm64"
	ARMv7 string = "armv7"
)

type Argument struct {
	Key   string `yaml:"key"`
	Value string `yaml:"value"`
}

type Tag struct {
	Name string   `yaml:"name"`
	Tags []string `yaml:"tags"`
}

type Build struct {
	Architecture string     `yaml:"arch"`
	Dockerfile   string     `yaml:"dockerfile"`
	Tags         []string   `yaml:"tags"`
	Arguments    []Argument `yaml:"args"`
	Context      string     `yaml:"context"`
}

type Repository struct {
	Name            string     `yaml:"name"`
	Library         string     `yaml:"library"`
	Path            string     `yaml:"path"`
	GlobalArguments []Argument `yaml:"args"`
	Tags            []Tag      `yaml:"tags"`
	Builds          []Build    `yaml:"builds"`
}

type Job struct {
	Registries   []string     `yaml:"registries"`
	Repositories []Repository `yaml:"repos"`
}
